// deployer DockerModule implementation
// Copyright (C) 2024 Jean-Cloud
// GNU General Public License v3

#include "DockerModule.h"
#include "BashManager.h"

//constructor and destructor inline 

//public methods
int DockerModule::prepare()
{
	return BashManager::execute("systemctl start docker docker.socket");
}

int DockerModule::deploy (Service service)
{
	//pulling images
	int pulling =BashManager::execute("docker-compose pull")==0;
	if(pulling==0){
		//starting service
		int starting=BashManager::execute("docker-compose up -d --remove-orphans"); 

	}else{
		cerr << "Error in DockerModule deploying "<< service << endl;
		return -1;
	}

	return 0;
}
int DockerModule::clean ()
{
	BashManager::execute("docker-compose down --rmi all --remove-orphans");
	/*
	if ! "$deploy" ; then
    section "Remove stray containers"
    while read container ; do
        [ -z "$container" ] && continue || true
        echo "Removing $container"
        run docker rm "$container"
    done <<< "$(docker ps | grep "$docker_service" | cut -d ' ' -f 1)"
fi
*/
	return 0;
}